diff --git a/web/pgadmin/static/js/tree/tree_nodes.ts b/web/pgadmin/static/js/tree/tree_nodes.ts
new file mode 100644
index 000000000..d1a40e6c8
--- /dev/null
+++ b/web/pgadmin/static/js/tree/tree_nodes.ts
@@ -0,0 +1,298 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2021, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+
+import * as BrowserFS from 'browserfs'
+import url_for from 'sources/url_for';
+import pgAdmin from 'sources/pgadmin';
+import _ from 'underscore';
+import { FileType } from 'react-aspen'
+import { findInTree } from './tree';
+
+import { dirname } from 'path-fx';
+
+export class ManageTreeNodes {
+  constructor(fs) {
+    this.tree = {}
+	this.tempTree = new TreeNode(undefined, {});
+  }
+
+  public init = (_root: string) => new Promise((res, rej) => {
+    let node = {parent: null, children: [], data: null};
+    this.tree = {};
+    this.tree[_root] = {name: 'root', type: FileType.Directory, metadata: node};
+    res();
+  })
+
+  public updateNode = (_path, _data)  => new Promise((res, rej) => {
+    if (_path in this.tree) {
+      const item = this.tree[_path];
+      item.name = _data.label;
+      item.metadata.data = _data;
+    }
+    res(true);
+  })
+
+  public removeNode = async (_path, _removeOnlyChild)  => {
+    const item = this.findNode(_path);
+
+    if (item && item.parentNode) {
+      item.children = [];
+      item.parentNode.children.splice(item.parentNode.children.indexOf(item), 1);
+    }
+    return true;
+  };
+
+  findNode(path) {
+    if (path === null || path === undefined || path.length === 0 || path == '/browser') {
+      return this.tempTree;
+    }
+    return findInTree(this.tempTree, path);
+  }
+
+  public addNode = (_parent: string, _path: string, _data: []) => new Promise((res, rej) => {
+    _data.type = _data.inode ? FileType.Directory : FileType.File;
+    _data._label = _data.label;
+    _data.label = _.escape(_data.label);
+
+    _data.is_collection = isCollectionNode(_data._type);
+    let nodeData = {parent: _parent, children: [], data: _data};
+
+    let tmpParentNode = this.findNode(_parent);
+    let treeNode = new TreeNode(_data.id, _data, {}, tmpParentNode, nodeData, _data.type);
+
+    if (tmpParentNode !== null && tmpParentNode !== undefined) tmpParentNode.children.push(treeNode);
+
+    res(treeNode);
+  })
+
+  public readNode = (_path: string) => new Promise<string[]>((res, rej) => {
+      let temp_tree_path = _path;
+      let node = this.findNode(_path);
+
+      if (node && node.children.length > 0) {
+        if (!node.type === FileType.File) {
+          rej("It's a leaf node")
+        }
+        else {
+          if (node.children.length != 0) res(node.children)
+        }
+      }
+
+      var self = this;
+
+      async function loadData() {
+        let url = '';
+        if (_path == '/browser') {
+          url = url_for('browser.nodes');
+        } else {
+          let _parent_url = self.generate_url(_path);
+          if (node.metadata.data._pid == null ) {
+            url = node.metadata.data._type + '/children/' + node.metadata.data._id;
+          }
+          else {
+            if (node.metadata.data._type.includes("coll-")) {
+              let _type = node.metadata.data._type.replace("coll-", "")
+              url = _type + '/nodes/' + _parent_url;
+            }
+            else {
+              url = node.metadata.data._type + '/children/' + _parent_url + '/' + node.metadata.data._id;
+            }
+        }
+
+        temp_tree_path = node.path;
+
+        if (node.metadata.data._type == 'server' && !node.metadata.data.connected) {
+          url = null;
+        }
+      }
+
+      async function jsonData(url) {
+        let res = await fetch(url, {
+          headers: {
+            'X-Requested-With': 'XMLHttpRequest',
+            'X-pgA-CSRFToken': pgAdmin.csrf_token
+          },
+        });
+
+        if (res.status == 200) {
+          try {
+            let json = await res.json();
+            return json.data;
+          } catch (e) {
+            console.warn(e);
+          }
+        }
+        throw new Error("Node Load Error...");
+        return [];
+      }
+
+      let treeData = null;
+      if (url) treeData = await jsonData(url);
+
+      const Path = BrowserFS.BFSRequire('path')
+      const fill = async (tree) => {
+        for (let idx in tree) {
+          const _node = tree[idx]
+          const _pathl = Path.join(_path, _node.id)
+          await self.addNode(temp_tree_path, _pathl, _node);
+        }
+      }
+
+      let d = await fill(treeData);
+      if (node.children.length > 0) res(node.children);
+      else res(null);
+
+    }
+    loadData();
+  })
+
+  public generate_url = (path: string) => {
+    let _path = path;
+    let _parent_path = [];
+    while(_path != '/') {
+      let node = this.findNode(_path);
+      let _parent = dirname(_path);
+      if(node.parentNode && node.parentNode.path == _parent) {
+        if (node.parentNode.metadata.data !== null && !node.parentNode.metadata.data._type.includes('coll-'))
+          _parent_path.push(node.parentNode.metadata.data._id);
+     }
+     _path = _parent;
+    }
+    let _rev_arr = _parent_path.reverse();
+    return _rev_arr.join("/");
+  }
+}
+
+
+
+export class TreeNode {
+  constructor(id, data, domNode, parent, metadata, type) {
+    this.id = id;
+    this.data = data;
+    this.setParent(parent);
+    this.children = [];
+    this.domNode = domNode;
+    this.metadata = metadata;
+    this.name = metadata ? metadata.data.label : "";
+    this.type = type ? type : undefined;
+  }
+
+  hasParent() {
+    return this.parentNode !== null && this.parentNode !== undefined;
+  }
+
+  parent() {
+    return this.parentNode;
+  }
+
+  setParent(parent) {
+    this.parentNode = parent;
+    this.path = this.id;
+    if (this.id)
+      if (parent !== null && parent !== undefined && parent.path !== undefined) {
+        this.path = parent.path + '/' + this.id;
+      } else {
+        this.path =  '/browser/' + this.id;
+      }
+  }
+
+  getData() {
+    if (this.data === undefined) {
+      return undefined;
+    } else if (this.data === null) {
+      return null;
+    }
+    return Object.assign({}, this.data);
+  }
+
+  getHtmlIdentifier() {
+    return this.domNode;
+  }
+
+  /*
+   * Find the ancestor with matches this condition
+   */
+  ancestorNode(condition) {
+    let node = this;
+
+    while (node.hasParent()) {
+      node = node.parent();
+      if (condition(node)) {
+        return node;
+      }
+    }
+
+    return null;
+  }
+
+  /**
+   * Given a condition returns true if the current node
+   * or any of the parent nodes condition result is true
+   */
+  anyFamilyMember(condition) {
+    if(condition(this)) {
+      return true;
+    }
+
+    return this.ancestorNode(condition) !== null;
+  }
+  anyParent(condition) {
+    return this.ancestorNode(condition) !== null;
+  }
+
+  reload(tree) {
+    return new Promise((resolve)=>{
+      this.unload(tree)
+        .then(()=>{
+          tree.setInode(this.domNode);
+          tree.deselect(this.domNode);
+          setTimeout(() => {
+            tree.selectNode(this.domNode);
+          }, 0);
+          resolve();
+        });
+    });
+  }
+
+  unload(tree) {
+    return new Promise((resolve, reject)=>{
+      this.children = [];
+      tree.unload(this.domNode)
+        .then(
+          ()=>{
+            resolve(true);
+          },
+          ()=>{
+            reject();
+          });
+    });
+  }
+
+
+  open(tree, suppressNoDom) {
+    return new Promise((resolve, reject)=>{
+      if(suppressNoDom && (this.domNode == null || typeof(this.domNode) === 'undefined')) {
+        resolve(true);
+      } else if(tree.isOpen(this.domNode)) {
+        resolve(true);
+      } else {
+        tree.open(this.domNode).then(val => resolve(true), err => reject(true));
+      }
+    });
+  }
+
+}
+
+export function isCollectionNode(node) {
+    if (pgAdmin.Browser.Nodes && node in pgAdmin.Browser.Nodes) {
+      if (pgAdmin.Browser.Nodes[node].is_collection !== undefined) return pgAdmin.Browser.Nodes[node].is_collection;
+      else return false;
+    }
+    return false;
+}
diff --git a/web/pgadmin/static/js/tree/tree_utils.js b/web/pgadmin/static/js/tree/tree_utils.js
index be6ca6df0..97b009ab4 100644
--- a/web/pgadmin/static/js/tree/tree_utils.js
+++ b/web/pgadmin/static/js/tree/tree_utils.js
@@ -11,8 +11,8 @@ import gettext from 'sources/gettext';
 
 export function retrieveAncestorOfTypeServer(pgBrowser, item, errorAlertTitle, alertify) {
   let serverInformation = null;
-  let aciTreeItem = item || pgBrowser.treeMenu.selected();
-  let treeNode = pgBrowser.treeMenu.findNodeByDomElement(aciTreeItem);
+  let aciTreeItem = item || pgBrowser.tree.selected();
+  let treeNode = pgBrowser.tree.findNodeByDomElement(aciTreeItem);
 
   if (treeNode) {
     let nodeData;
@@ -58,9 +58,8 @@ export function retrieveAncestorOfTypeServer(pgBrowser, item, errorAlertTitle, a
 
 export function retrieveAncestorOfTypeDatabase(pgBrowser, item, errorAlertTitle, alertify) {
   let databaseInfo = null;
-  let aciTreeItem = item || pgBrowser.treeMenu.selected();
-  let treeNode = pgBrowser.treeMenu.findNodeByDomElement(aciTreeItem);
-
+  let aciTreeItem = item || pgBrowser.tree.selected();
+  let treeNode = pgBrowser.tree.findNodeByDomElement(aciTreeItem);
   if (treeNode) {
     if(treeNode.getData()._type === 'database') {
       databaseInfo = treeNode.getData();
diff --git a/web/pgadmin/static/js/utils.js b/web/pgadmin/static/js/utils.js
index 63186edf5..bd3e38578 100644
--- a/web/pgadmin/static/js/utils.js
+++ b/web/pgadmin/static/js/utils.js
@@ -8,7 +8,6 @@
 //////////////////////////////////////////////////////////////////////////
 
 import _ from 'underscore';
-import { getTreeNodeHierarchyFromIdentifier } from 'sources/tree/pgadmin_tree_node';
 import $ from 'jquery';
 import gettext from 'sources/gettext';
 import 'wcdocker';
@@ -237,7 +236,7 @@ export function quote_ident(value) {
 }
 
 export function fully_qualify(pgBrowser, data, item) {
-  const parentData = getTreeNodeHierarchyFromIdentifier.call(pgBrowser, item);
+  const parentData = pgBrowser.tree.getTreeNodeHierarchy(item);
   let namespace = '';
 
   if (parentData.schema !== undefined) {
diff --git a/web/pgadmin/tools/backup/static/js/backup.js b/web/pgadmin/tools/backup/static/js/backup.js
index 9bb32f172..8d6c49819 100644
--- a/web/pgadmin/tools/backup/static/js/backup.js
+++ b/web/pgadmin/tools/backup/static/js/backup.js
@@ -199,7 +199,7 @@ define([
         if (!_.isUndefined(m.get('type')) && m.get('type') === 'server') {
           var t = pgBrowser.tree,
             i = t.selected(),
-            d = i && i.length == 1 ? t.itemData(i) : undefined;
+            d = i ? t.itemData(i) : undefined;
           return _.isUndefined(d) ? false : d.version >= 110000;
         }
         return true;
@@ -391,7 +391,7 @@ define([
         visible: function() {
           var t = pgBrowser.tree,
             i = t.selected(),
-            d = i && i.length == 1 ? t.itemData(i) : undefined,
+            d = i  ? t.itemData(i) : undefined,
             s = _.isUndefined(d) ? undefined : pgBrowser.Nodes[d._type].getTreeNodeHierarchy(i)['server'];
 
           return _.isUndefined(s) ? false : s.version >= 110000;
@@ -466,7 +466,7 @@ define([
 
           var t = pgBrowser.tree,
             i = t.selected(),
-            d = i && i.length == 1 ? t.itemData(i) : undefined,
+            d = i  ? t.itemData(i) : undefined,
             s = _.isUndefined(d) ? undefined : pgBrowser.Nodes[d._type].getTreeNodeHierarchy(i)['server'];
 
           return _.isUndefined(s) ? false : s.version >= 110000;
@@ -518,7 +518,7 @@ define([
         disabled: function(m) {
           var t = pgBrowser.tree,
             i = t.selected(),
-            d = i && i.length == 1 ? t.itemData(i) : undefined,
+            d = i  ? t.itemData(i) : undefined,
             s = _.isUndefined(d) ? undefined : pgBrowser.Nodes[d._type].getTreeNodeHierarchy(i)['server'];
 
           if (!_.isUndefined(s) && s.version >= 120000)
@@ -632,7 +632,7 @@ define([
         label: gettext('Backup...'),
         icon: 'fa fa-save',
         enable: supportedNodes.enabled.bind(
-          null, pgBrowser.treeMenu, menuUtils.backupSupportedNodes
+          null, pgBrowser.tree, menuUtils.backupSupportedNodes
         ),
         data: {
           data_disabled: gettext('Please select any database or schema or table from the browser tree to take Backup.'),
@@ -650,7 +650,7 @@ define([
           label: gettext('Backup...'),
           icon: 'fa fa-save',
           enable: supportedNodes.enabled.bind(
-            null, pgBrowser.treeMenu, menuUtils.backupSupportedNodes
+            null, pgBrowser.tree, menuUtils.backupSupportedNodes
           ),
         });
       }
diff --git a/web/pgadmin/tools/backup/static/js/backup_dialog_wrapper.js b/web/pgadmin/tools/backup/static/js/backup_dialog_wrapper.js
index 5a86bf82e..b45cb8008 100644
--- a/web/pgadmin/tools/backup/static/js/backup_dialog_wrapper.js
+++ b/web/pgadmin/tools/backup/static/js/backup_dialog_wrapper.js
@@ -7,7 +7,6 @@
 //
 //////////////////////////////////////////////////////////////
 
-import {getTreeNodeHierarchyFromElement} from '../../../../static/js/tree/pgadmin_tree_node';
 import axios from 'axios/index';
 import gettext from '../../../../static/js/gettext';
 import url_for from '../../../../static/js/url_for';
@@ -105,7 +104,7 @@ export class BackupDialogWrapper extends DialogWrapper {
       this.main(title);
     }
 
-    const treeInfo = getTreeNodeHierarchyFromElement(this.pgBrowser, selectedTreeNode);
+    const treeInfo = this.pgBrowser.tree.getTreeNodeHierarchy(selectedTreeNode);
     const dialog = this.createDialog(node, treeInfo, this.typeOfDialog, $container);
     this.addAlertifyClassToBackupNodeChildNodes();
     dialog.render();
@@ -162,10 +161,7 @@ export class BackupDialogWrapper extends DialogWrapper {
         'sid': serverIdentifier,
       });
 
-      const treeInfo = getTreeNodeHierarchyFromElement(
-        this.pgBrowser,
-        selectedTreeNode
-      );
+      const treeInfo = this.pgBrowser.tree.getTreeNodeHierarchy(selectedTreeNode);
 
       this.setExtraParameters(selectedTreeNode, treeInfo);
       let backupDate = this.view.model.toJSON();
@@ -222,7 +218,7 @@ export class BackupDialogWrapper extends DialogWrapper {
   }
 
   getSelectedNode() {
-    const tree = this.pgBrowser.treeMenu;
+    const tree = this.pgBrowser.tree;
     const selectedNode = tree.selected();
     if (selectedNode) {
       return tree.findNodeByDomElement(selectedNode);
@@ -260,10 +256,7 @@ export class BackupDialogWrapper extends DialogWrapper {
   }
 
   retrieveServerIdentifier(node, selectedTreeNode) {
-    const treeInfo = getTreeNodeHierarchyFromElement(
-      this.pgBrowser,
-      selectedTreeNode
-    );
+    const treeInfo = this.pgBrowser.tree.getTreeNodeHierarchy(selectedTreeNode);
     return treeInfo.server._id;
   }
 
diff --git a/web/pgadmin/tools/datagrid/static/js/datagrid.js b/web/pgadmin/tools/datagrid/static/js/datagrid.js
index 84995d235..cabad10cc 100644
--- a/web/pgadmin/tools/datagrid/static/js/datagrid.js
+++ b/web/pgadmin/tools/datagrid/static/js/datagrid.js
@@ -213,7 +213,7 @@ define('pgadmin.datagrid', [
         const transId = commonUtils.getRandomInt(1, 9999999);
         var t = pgBrowser.tree,
           i = aciTreeIdentifier || t.selected(),
-          d = i && i.length == 1 ? t.itemData(i) : undefined;
+          d = i ? t.itemData(i) : undefined;
 
         //Open query tool with create script if copy_sql_to_query_tool is true else open blank query tool
         var preference = pgBrowser.get_preference('sqleditor', 'copy_sql_to_query_tool');
@@ -312,7 +312,7 @@ define('pgadmin.datagrid', [
                   if(panel_data.$titleText[0].innerHTML.includes('File - ')) {
                     is_file = true;
                   }
-                  var selected_item = pgBrowser.treeMenu.selected();
+                  var selected_item = pgBrowser.tree.selected();
                   var panel_titles = '';
 
                   if(is_query_tool) {
diff --git a/web/pgadmin/tools/datagrid/static/js/datagrid_panel_title.js b/web/pgadmin/tools/datagrid/static/js/datagrid_panel_title.js
index 368da487c..660fd3c81 100644
--- a/web/pgadmin/tools/datagrid/static/js/datagrid_panel_title.js
+++ b/web/pgadmin/tools/datagrid/static/js/datagrid_panel_title.js
@@ -7,7 +7,6 @@
 //
 //////////////////////////////////////////////////////////////
 
-import {getTreeNodeHierarchyFromIdentifier} from '../../../../static/js/tree/pgadmin_tree_node';
 import gettext from 'sources/gettext';
 import Alertify from 'pgadmin.alertifyjs';
 import pgWindow from 'sources/window';
@@ -26,11 +25,12 @@ function isServerInformationAvailable(parentData) {
 export function getPanelTitle(pgBrowser, selected_item=null, custom_title=null, parentData=null, conn_title=false, db_label=null) {
   var preferences = pgBrowser.get_preferences_for_module('browser');
   if(selected_item == null && parentData == null) {
-    selected_item = pgBrowser.treeMenu.selected();
+    selected_item = pgBrowser.tree.selected();
   }
 
   if(parentData == null) {
-    parentData = getTreeNodeHierarchyFromIdentifier.call(pgBrowser, selected_item);
+    parentData = pgBrowser.tree.getTreeNodeHierarchy(selected_item);
+    if(parentData == null) return;
     if (isServerInformationAvailable(parentData)) {
       return;
     }
diff --git a/web/pgadmin/tools/datagrid/static/js/show_data.js b/web/pgadmin/tools/datagrid/static/js/show_data.js
index b1e19aaa4..018f51607 100644
--- a/web/pgadmin/tools/datagrid/static/js/show_data.js
+++ b/web/pgadmin/tools/datagrid/static/js/show_data.js
@@ -8,7 +8,6 @@
 //////////////////////////////////////////////////////////////
 import gettext from '../../../../static/js/gettext';
 import url_for from '../../../../static/js/url_for';
-import {getTreeNodeHierarchyFromIdentifier} from '../../../../static/js/tree/pgadmin_tree_node';
 import {getDatabaseLabel, generateTitle} from './datagrid_panel_title';
 import CodeMirror from 'bundled_codemirror';
 import * as SqlEditorUtils from 'sources/sqleditor_utils';
@@ -25,7 +24,7 @@ export function showDataGrid(
   filter=false,
   preferences=null
 ) {
-  const node = pgBrowser.treeMenu.findNodeByDomElement(aciTreeIdentifier);
+  const node = pgBrowser.tree.findNodeByDomElement(aciTreeIdentifier);
   if (node === undefined || !node.getData()) {
     alertify.alert(
       gettext('Data Grid Error'),
@@ -34,9 +33,7 @@ export function showDataGrid(
     return;
   }
 
-  const parentData = getTreeNodeHierarchyFromIdentifier.call(
-    pgBrowser,
-    aciTreeIdentifier
+  const parentData = pgBrowser.tree.getTreeNodeHierarchy(  aciTreeIdentifier
   );
 
   if (hasServerOrDatabaseConfiguration(parentData)
@@ -293,14 +290,13 @@ function hasSchemaOrCatalogOrViewInformation(parentData) {
 export function generateDatagridTitle(pgBrowser, aciTreeIdentifier, custom_title=null, backend_entity=null) {
   //const baseTitle = getPanelTitle(pgBrowser, aciTreeIdentifier);
   var preferences = pgBrowser.get_preferences_for_module('browser');
-  const parentData = getTreeNodeHierarchyFromIdentifier.call(
-    pgBrowser,
+  const parentData = pgBrowser.tree.getTreeNodeHierarchy(
     aciTreeIdentifier
   );
 
   const namespaceName = retrieveNameSpaceName(parentData);
   const db_label = !_.isUndefined(backend_entity) && backend_entity != null && backend_entity.hasOwnProperty('db_name') ? backend_entity['db_name'] : getDatabaseLabel(parentData);
-  const node = pgBrowser.treeMenu.findNodeByDomElement(aciTreeIdentifier);
+  const node = pgBrowser.tree.findNodeByDomElement(aciTreeIdentifier);
 
   var dtg_title_placeholder = '';
   if(custom_title) {
diff --git a/web/pgadmin/tools/datagrid/static/js/show_query_tool.js b/web/pgadmin/tools/datagrid/static/js/show_query_tool.js
index 33b894788..11e9d1f98 100644
--- a/web/pgadmin/tools/datagrid/static/js/show_query_tool.js
+++ b/web/pgadmin/tools/datagrid/static/js/show_query_tool.js
@@ -9,7 +9,6 @@
 
 import gettext from '../../../../static/js/gettext';
 import url_for from '../../../../static/js/url_for';
-import {getTreeNodeHierarchyFromIdentifier} from '../../../../static/js/tree/pgadmin_tree_node';
 import {getPanelTitle} from './datagrid_panel_title';
 import {getRandomInt} from 'sources/utils';
 import $ from 'jquery';
@@ -52,7 +51,7 @@ export function showQueryTool(datagrid, pgBrowser, alertify, url, aciTreeIdentif
   const sURL = url || '';
   const queryToolTitle = generateTitle(pgBrowser, aciTreeIdentifier);
 
-  const currentNode = pgBrowser.treeMenu.findNodeByDomElement(aciTreeIdentifier);
+  const currentNode = pgBrowser.tree.findNodeByDomElement(aciTreeIdentifier);
   if (currentNode === undefined) {
     alertify.alert(
       gettext('Query Tool Error'),
@@ -61,8 +60,7 @@ export function showQueryTool(datagrid, pgBrowser, alertify, url, aciTreeIdentif
     return;
   }
 
-  const parentData = getTreeNodeHierarchyFromIdentifier.call(
-    pgBrowser, aciTreeIdentifier);
+  const parentData = pgBrowser.tree.getTreeNodeHierarchy(currentNode);
 
   if (hasServerInformations(parentData)) {
     return;
diff --git a/web/pgadmin/tools/debugger/static/js/debugger.js b/web/pgadmin/tools/debugger/static/js/debugger.js
index 6632b83c1..ea34c2bd5 100644
--- a/web/pgadmin/tools/debugger/static/js/debugger.js
+++ b/web/pgadmin/tools/debugger/static/js/debugger.js
@@ -227,13 +227,12 @@ define([
       // Find the function is really available in database
       var tree = pgBrowser.tree,
         info = tree.selected(),
-        d_ = info && info.length == 1 ? tree.itemData(info) : undefined,
-        node = d_ && pgBrowser.Nodes[d_._type];
+        d_ = info ? tree.itemData(info) : undefined;
 
       if (!d_)
         return false;
 
-      var treeInfo = node.getTreeNodeHierarchy.apply(node, [info]);
+      var treeInfo = tree.getTreeNodeHierarchy(info);
 
       // For indirect debugging user must be super user
       if (data && data.debug_type && data.debug_type == 'indirect' &&
@@ -302,13 +301,13 @@ define([
     check_func_debuggable: function(args, item) {
       var t = pgBrowser.tree,
         i = item || t.selected(),
-        d = i && i.length == 1 ? t.itemData(i) : undefined,
+        d = i ? t.itemData(i) : undefined,
         node = d && pgBrowser.Nodes[d._type];
 
       if (!d)
         return;
 
-      var treeInfo = node.getTreeNodeHierarchy.apply(node, [i]),
+      var treeInfo = t.getTreeNodeHierarchy(i),
         _url = this.generate_url('init', treeInfo, node);
 
       var self = this;
@@ -338,16 +337,15 @@ define([
       var self = this;
       var t = pgBrowser.tree,
         i = item || t.selected(),
-        d = i && i.length == 1 ? t.itemData(i) : undefined,
-        node = d && pgBrowser.Nodes[d._type],
-        tree_data = pgBrowser.treeMenu.translateTreeNodeIdFromACITree(i),
-        db_data = pgBrowser.treeMenu.findNode(tree_data.slice(0,4)),
+        d = i ? t.itemData(i) : undefined,
+        tree_data = pgBrowser.tree.translateTreeNodeIdFromReactTree(i),
+        db_data = pgBrowser.tree.findNode(tree_data[3]),
         dbNode = db_data.domNode;
 
       if (!d)
         return;
 
-      var treeInfo = node.getTreeNodeHierarchy.apply(node, [i]),
+      var treeInfo = t.getTreeNodeHierarchy(i),
         baseUrl;
 
       if (d._type == 'function' || d._type == 'edbfunc') {
@@ -515,10 +513,10 @@ define([
 
       var t = pgBrowser.tree,
         i = item || t.selected(),
-        d = i && i.length == 1 ? t.itemData(i) : undefined,
+        d = i ? t.itemData(i) : undefined,
         node = d && pgBrowser.Nodes[d._type],
-        tree_data = pgBrowser.treeMenu.translateTreeNodeIdFromACITree(i),
-        db_data = pgBrowser.treeMenu.findNode(tree_data.slice(0,4)),
+        tree_data = pgBrowser.tree.translateTreeNodeIdFromReactTree(i),
+        db_data = pgBrowser.tree.findNode(tree_data[3]),
         dbNode = db_data.domNode;
 
       if (!d)
@@ -526,7 +524,7 @@ define([
 
       var is_edb_proc = d._type == 'edbproc';
 
-      var treeInfo = node.getTreeNodeHierarchy.apply(node, [i]),
+      var treeInfo = t.getTreeNodeHierarchy(i),
         _url = this.generate_url('init', treeInfo, node);
 
       $.ajax({
@@ -546,13 +544,12 @@ define([
           // Directly open the panel
             var _t = pgBrowser.tree,
               _i = _t.selected(),
-              _d = _i && _i.length == 1 ? _t.itemData(_i) : undefined,
-              _node = _d && pgBrowser.Nodes[_d._type];
+              _d = _i ? _t.itemData(_i) : undefined;
 
             if (!_d)
               return;
 
-            var newTreeInfo = _node.getTreeNodeHierarchy.apply(_node, [_i]),
+            var newTreeInfo = _t.getTreeNodeHierarchy(_i),
               baseUrl;
 
             if (_d._type == 'function' || _d._type == 'edbfunc') {
diff --git a/web/pgadmin/tools/debugger/static/js/debugger_ui.js b/web/pgadmin/tools/debugger/static/js/debugger_ui.js
index 43ee2f3f6..2d6717144 100644
--- a/web/pgadmin/tools/debugger/static/js/debugger_ui.js
+++ b/web/pgadmin/tools/debugger/static/js/debugger_ui.js
@@ -188,13 +188,12 @@ define([
             if (restart_debug == 0) {
               var t = pgBrowser.tree,
                 i = t.selected(),
-                d = i && i.length == 1 ? t.itemData(i) : undefined,
-                node = d && pgBrowser.Nodes[d._type];
+                d = i ? t.itemData(i) : undefined;
 
               if (!d)
                 return;
 
-              var treeInfo = node.getTreeNodeHierarchy.apply(node, [i]),
+              var treeInfo = t.getTreeNodeHierarchy(i),
                 _Url;
 
               if (d._type == 'function') {
@@ -623,13 +622,12 @@ define([
               if (self.setting('restart_debug') == 0) {
                 var t = pgBrowser.tree,
                   i = t.selected(),
-                  d = i && i.length == 1 ? t.itemData(i) : undefined,
-                  node = d && pgBrowser.Nodes[d._type];
+                  d = i ? t.itemData(i) : undefined;
 
                 if (!d)
                   return;
 
-                var treeInfo = node.getTreeNodeHierarchy.apply(node, [i]);
+                var treeInfo = t.getTreeNodeHierarchy(i);
               }
 
               var args_value_list = [];
@@ -939,8 +937,7 @@ define([
                 if (!item_data)
                   return;
 
-                let node_ele = pgBrowser.Nodes[item_data._type];
-                let tree_info = node_ele.getTreeNodeHierarchy.call(node_ele, selected_item);
+                let tree_info = pgBrowser.tree.getTreeNodeHierarchy(selected_item);
 
                 base_url = url_for('debugger.clear_arguments', {
                   'sid': tree_info.server._id,
diff --git a/web/pgadmin/tools/erd/static/js/erd_module.js b/web/pgadmin/tools/erd/static/js/erd_module.js
index 61327214f..70f671ad6 100644
--- a/web/pgadmin/tools/erd/static/js/erd_module.js
+++ b/web/pgadmin/tools/erd/static/js/erd_module.js
@@ -8,7 +8,6 @@
 //////////////////////////////////////////////////////////////
 
 import Alertify from 'pgadmin.alertifyjs';
-import {getTreeNodeHierarchyFromIdentifier} from 'sources/tree/pgadmin_tree_node';
 import {getPanelTitle} from 'tools/datagrid/static/js/datagrid_panel_title';
 import {getRandomInt, registerDetachEvent} from 'sources/utils';
 
@@ -98,10 +97,9 @@ export function initialize(gettext, url_for, $, _, pgAdmin, csrfToken, pgBrowser
       return isEnabled;
     },
 
-    // Callback to draw schema diff for objects
+    // Callback to draw ERD Tool for objects
     showErdTool: function(data, aciTreeIdentifier, gen=false) {
-      const node = pgBrowser.treeMenu.findNodeByDomElement(aciTreeIdentifier);
-      if (node === undefined || !node.getData()) {
+      if (aciTreeIdentifier === undefined) {
         Alertify.alert(
           gettext('ERD Error'),
           gettext('No object selected.')
@@ -109,10 +107,7 @@ export function initialize(gettext, url_for, $, _, pgAdmin, csrfToken, pgBrowser
         return;
       }
 
-      const parentData = getTreeNodeHierarchyFromIdentifier.call(
-        pgBrowser,
-        aciTreeIdentifier
-      );
+      const parentData = pgBrowser.tree.getTreeNodeHierarchy(aciTreeIdentifier);
 
       if(_.isUndefined(parentData.database)) {
         Alertify.alert(
diff --git a/web/pgadmin/tools/grant_wizard/static/js/grant_wizard.js b/web/pgadmin/tools/grant_wizard/static/js/grant_wizard.js
index efc8fe56b..1f26c8d8e 100644
--- a/web/pgadmin/tools/grant_wizard/static/js/grant_wizard.js
+++ b/web/pgadmin/tools/grant_wizard/static/js/grant_wizard.js
@@ -52,7 +52,7 @@ define([
         label: gettext('Grant Wizard...'),
         icon: 'fa fa-unlock',
         enable: supportedNodes.enabled.bind(
-          null, pgBrowser.treeMenu, menuUtils.supportedNodes
+          null, pgBrowser.tree, menuUtils.supportedNodes
         ),
         data: {
           data_disabled: gettext('Please select any database, schema or schema objects from the browser tree to access Grant Wizard Tool.'),
@@ -71,7 +71,7 @@ define([
           label: gettext('Grant Wizard...'),
           icon: 'fa fa-unlock',
           enable: supportedNodes.enabled.bind(
-            null, pgBrowser.treeMenu, menuUtils.supportedNodes
+            null, pgBrowser.tree, menuUtils.supportedNodes
           ),
         });
       }
@@ -112,8 +112,8 @@ define([
               Alertify.pgDialogBuild.apply(this);
               var t = pgBrowser.tree,
                 i = t.selected(),
-                d = this.d = i && i.length == 1 ? t.itemData(i) : undefined,
-                info = this.info = pgBrowser.Node.getTreeNodeHierarchy(i);
+                d = this.d = i ? t.itemData(i) : undefined,
+                info = this.info = pgBrowser.tree.getTreeNodeHierarchy(i);
 
               var sid = info.server._id,
                 did = info.database._id;
diff --git a/web/pgadmin/tools/import_export/static/js/import_export.js b/web/pgadmin/tools/import_export/static/js/import_export.js
index 1dd8e1a91..92f112ba1 100644
--- a/web/pgadmin/tools/import_export/static/js/import_export.js
+++ b/web/pgadmin/tools/import_export/static/js/import_export.js
@@ -410,7 +410,7 @@ define([
         label: gettext('Import/Export...'),
         icon: 'fa fa-shopping-cart',
         enable: supportedNodes.enabled.bind(
-          null, pgBrowser.treeMenu, ['table']
+          null, pgBrowser.tree, ['table']
         ),
         data: {
           data_disabled: gettext('Please select any table from the browser tree to Import/Export data.'),
@@ -433,7 +433,7 @@ define([
         }
 
         if (pgBrowser.tree.hasParent(i)) {
-          i = $(pgBrowser.tree.parent(i));
+          i = pgBrowser.tree.parent(i);
         } else {
           Alertify.alert(gettext('Please select server or child node from tree.'));
           break;
@@ -450,13 +450,13 @@ define([
 
       var t = pgBrowser.tree;
       i = item || t.selected();
-      var d = i && i.length == 1 ? t.itemData(i) : undefined,
+      var d = i  ? t.itemData(i) : undefined,
         node = d && pgBrowser.Nodes[d._type];
 
       if (!d)
         return;
 
-      var treeInfo = node.getTreeNodeHierarchy.apply(node, [i]);
+      var treeInfo = t && t.getTreeNodeHierarchy(i);
 
       if (!Alertify.ImportDialog) {
         Alertify.dialog('ImportDialog', function factory() {
